unit adxOLInspPopup_IMPL;

interface

uses
  SysUtils, ComObj, ComServ, ActiveX, Variants, adxAddIn, adxOLInspPopup_TLB,
  StdVcl, Classes, Outlook2000;

type
  TADX_OLInspPopup = class(TadxAddin, IADX_OLInspPopup)
  end;

  TAddInModule = class(TadxCOMAddInModule)
    InspCmdBar: TadxOlInspectorCommandBar;
    procedure CommonButtonClick(Sender: TObject);
    procedure adxCOMAddInModuleAddInInitialize(Sender: TObject);
    procedure adxCOMAddInModuleAddInBeginShutdown(Sender: TObject);
  private
  protected
  public
  end;

implementation

{$R *.dfm}

uses Dialogs, Office2000;

procedure TAddInModule.adxCOMAddInModuleAddInInitialize(Sender: TObject);
begin
  FastCommandBarSearch := True;
end;

procedure TAddInModule.adxCOMAddInModuleAddInBeginShutdown(Sender: TObject);
var
  i: Integer;
  PopupControl: TadxCommandBarPopup;
  ICmdBars: _CommandBars;
  ICtrl: CommandBarControl;
begin
  // MS Word
  if HostType = ohaWord then begin
    ICmdBars := WordApp.CommandBars;
    if Assigned(ICmdBars) then
      try
        PopupControl := InspCmdBar.Controls[0].AsPopup;
        // buttons
        for i := 0 to PopupControl.Controls.Count - 1 do begin
          ICtrl := ICmdBars.FindControl(EmptyParam, EmptyParam, PopupControl.Controls[i].OfficeTag, EmptyParam);
          if Assigned(ICtrl) then
            try
              ICtrl.Delete(False);
            finally
              ICtrl := nil;
            end;
        end;
        WordApp.NormalTemplate.Save;
      finally
        ICmdBars := nil;
      end;
  end;
end;

procedure TAddInModule.CommonButtonClick(Sender: TObject);
begin
  ShowMessage('Click! ' + (Sender as TadxCommandBarControl).AsButton.Caption);
end;

initialization
  TadxFactory.Create(ComServer, TADX_OLInspPopup, CLASS_ADX_OLInspPopup, TAddInModule);

end.
